import { system } from "@minecraft/server";

system.events.beforeWatchdogTerminate.subscribe(skyb => {

    skyb.cancel = true;

    console.warn(skyb.terminateReason.stackOverflow);

});

import { world } from '@minecraft/server'

import { ActionFormData } from '@minecraft/server-ui'

world.events.itemUse.subscribe(sky => {

    if (sky.item.typeId == "skyb:skyblock_generator") {

        Island(sky.source)

    }

})

world.events.beforeChat.subscribe((com) => {
    const player = com.sender
    const commes = com.message

    if (commes == "!sky list") {
        if (player.hasTag(`skyt`)) {
            com.cancel = true
            player.runCommandAsync(`tellraw @a {"rawtext":[{"text":"§l§3Skyblock Commands List:"}]}`)
            player.runCommandAsync(`tellraw @a {"rawtext":[{"text":"§6!sky voidpush true"}]}`)
            player.runCommandAsync(`tellraw @a {"rawtext":[{"text":"§6!sky voidpush false"}]}`)
            player.runCommandAsync(`tellraw @a {"rawtext":[{"text":"§6!sky end true"}]}`)
            player.runCommandAsync(`tellraw @a {"rawtext":[{"text":"§6!sky end false"}]}`)
        }
    }
    if (commes == "!sky voidpush true") {
        if (player.hasTag(`skyt`)) {
            com.cancel = true
            player.removeTag("void_p1")
            player.addTag("void_p")
            player.runCommandAsync(`tellraw @a[tag=void_p] {"rawtext":[{"text":"§lVoid Push: On"}]}`)
        }
    }
    if (commes == "!sky voidpush false") {
        if (player.hasTag(`skyt`)) {
            com.cancel = true
            player.removeTag("void_p")
            player.addTag("void_p1")
            player.runCommandAsync(`tellraw @a[tag=void_p1] {"rawtext":[{"text":"§lVoid Push: Off"}]}`)
        }
    }
    if (commes == "!sky end true") {
        if (player.hasTag(`skyt`)) {
            com.cancel = true
            player.removeTag("end1")
            player.addTag("end")
            player.runCommandAsync(`tellraw @a[tag=end] {"rawtext":[{"text":"§lEnd Portal: On"}]}`)
        }
    }
    if (commes == "!sky end false") {
        if (player.hasTag(`skyt`)) {
            com.cancel = true
            player.removeTag("end")
            player.addTag("end1")
            player.runCommandAsync(`tellraw @a[tag=end1] {"rawtext":[{"text":"§lEnd Portal: Off"}]}`)
        }
    }
})

function Island(player) {

    const form = new ActionFormData()

        .title("§l§3Create Your Island!")
        .button("§3Sky Factory Type", "textures/items/sky1")
        .button("§3L Shape Type", "textures/items/sky2")
        .button("§35x5 Flat World Type", "textures/items/sky3")
        .button("§33x3 Diamond Block Type", "textures/items/sky4")
        .button("§3Small Island Type", "textures/items/small_island")
        .button("§3Villager House Type", "textures/items/villager_house")
        .button("§3One Grass Type", "textures/items/sky5")
        .button("§3One Bedrock Type", "textures/items/sky6")

    //You can ban islands by adding "!"
    //Example: if (response.selection == 0) {
    //            if (!player.hasTag(`ptag`)) {
    //                if (!player.hasTag(`ncreate`)) {
    //                    player.addTag("skyf")
    //                }
    //            }

    form.show(player).then(response => {
        if (response.selection == 0) {
            if (player.hasTag(`ptag`)) {
                if (!player.hasTag(`ncreate`)) {
                    player.addTag("skyf")
                }
            }
            if (!player.hasTag(`skyf`)) {
                player.runCommandAsync(`tellraw @a[tag=!skyf] {"rawtext":[{"text":"§cThis island type has been banned!"}]}`)
            }
        }
        if (response.selection == 1) {
            if (player.hasTag(`ptag`)) {
                if (!player.hasTag(`ncreate`)) {
                    player.addTag("skyl")
                }
            }
            if (!player.hasTag(`skyl`)) {
                player.runCommandAsync(`tellraw @a[tag=!skyl] {"rawtext":[{"text":"§cThis island type has been banned!"}]}`)
            }
        }
        if (response.selection == 2) {
            if (player.hasTag(`ptag`)) {
                if (!player.hasTag(`ncreate`)) {
                    player.addTag("sky5x5f")
                }
            }
            if (!player.hasTag(`sky5x5f`)) {
                player.runCommandAsync(`tellraw @a[tag=!sky5x5f] {"rawtext":[{"text":"§cThis island type has been banned!"}]}`)
            }
        }
        if (response.selection == 3) {
            if (player.hasTag(`ptag`)) {
                if (!player.hasTag(`ncreate`)) {
                    player.addTag("sky3x3d")
                }
            }
            if (!player.hasTag(`sky3x3d`)) {
                player.runCommandAsync(`tellraw @a[tag=!sky3x3d] {"rawtext":[{"text":"§cThis island type has been banned!"}]}`)
            }
        }
        if (response.selection == 4) {
            if (player.hasTag(`ptag`)) {
                if (!player.hasTag(`ncreate`)) {
                    player.addTag("skysi")
                }
            }
            if (!player.hasTag(`skysi`)) {
                player.runCommandAsync(`tellraw @a[tag=!skysi] {"rawtext":[{"text":"§cThis island type has been banned!"}]}`)
            }
        }
        if (response.selection == 5) {
            if (player.hasTag(`ptag`)) {
                if (!player.hasTag(`ncreate`)) {
                    player.addTag("skyvh")
                }
            }
            if (!player.hasTag(`skyvh`)) {
                player.runCommandAsync(`tellraw @a[tag=!skyvh] {"rawtext":[{"text":"§cThis island type has been banned!"}]}`)
            }
        }
        if (response.selection == 6) {
            if (player.hasTag(`ptag`)) {
                if (!player.hasTag(`ncreate`)) {
                    player.addTag("skyog")
                }
            }
            if (!player.hasTag(`skyog`)) {
                player.runCommandAsync(`tellraw @a[tag=!skyog] {"rawtext":[{"text":"§cThis island type has been banned!"}]}`)
            }
        }
        if (response.selection == 7) {
            if (player.hasTag(`ptag`)) {
                if (!player.hasTag(`ncreate`)) {
                    player.addTag("skyob")
                }
            }
            if (!player.hasTag(`skyob`)) {
                player.runCommandAsync(`tellraw @a[tag=!skyob] {"rawtext":[{"text":"§cThis island type has been banned!"}]}`)
            }
        }
    }

    )
}